var _excluded = ["value", "onChange", "showSearch", "observer"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { AutoComplete } from 'antd';
import { compHoc, udp, UdpComponent } from "../util";
import { jsx as _jsx } from "react/jsx-runtime";
export var Combobox = compHoc( /*#__PURE__*/function (_UdpComponent) {
  _inherits(_class2, _UdpComponent);
  var _super = _createSuper(_class2);
  function _class2(props) {
    var _this;
    _classCallCheck(this, _class2);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "onHandlerChange", function (e) {
      var value = _this.labelInValue(e);
      if (_this.props.hasOwnProperty('value')) {
        // 外部受控
        _this.state.value = value;
        _this.props.onChange && _this.props.onChange(value);
      } else {
        _this.setValue(value);
      }
      _this.innerNotify([value], 'onChange').then();
    });
    _this.state.value = props.defaultValue;
    return _this;
  }
  _createClass(_class2, [{
    key: "setValue",
    value: function setValue(val, cb) {
      var _this2 = this;
      if (this.state.value === val) {
        return;
      }
      var value = this.labelInValue(val);
      this.setState(function (prev) {
        return _objectSpread(_objectSpread({}, prev), {}, {
          value: value
        });
      }, function () {
        _this2.props.onChange && _this2.props.onChange(value);
        cb && cb(value);
      });
    }
  }, {
    key: "getValue",
    value: function getValue() {
      var v = this.state.value;
      if ((v === null || v === void 0 ? void 0 : v.value) === undefined) {
        return v;
      }
      return v.value;
    }
  }, {
    key: "getRawValue",
    value: function getRawValue() {
      return this.labelInValue(this.state.value);
    }
  }, {
    key: "getText",
    value: function getText() {
      var _this$getRawValue;
      return (_this$getRawValue = this.getRawValue()) === null || _this$getRawValue === void 0 ? void 0 : _this$getRawValue.label;
    }
  }, {
    key: "labelInValue",
    value: function labelInValue(val) {
      var _val$value, _this$props$options$f;
      if (udp.isNullOrEmpty(val)) {
        return undefined;
      }
      var value = (_val$value = val.value) !== null && _val$value !== void 0 ? _val$value : val;
      return (_this$props$options$f = this.props.options.find(function (o) {
        return o.value === value;
      })) !== null && _this$props$options$f !== void 0 ? _this$props$options$f : {
        value: value,
        label: value
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        value = _this$props.value,
        onChange = _this$props.onChange,
        showSearch = _this$props.showSearch,
        observer = _this$props.observer,
        others = _objectWithoutProperties(_this$props, _excluded);
      return /*#__PURE__*/_jsx(AutoComplete, _objectSpread(_objectSpread({
        ref: this.outRef
      }, others), {}, {
        filterOption: function filterOption(inputValue, option) {
          if (udp.isString(option === null || option === void 0 ? void 0 : option.label)) {
            return (option === null || option === void 0 ? void 0 : option.label.toUpperCase().indexOf(inputValue.toUpperCase())) !== -1;
          }
          return false;
        },
        showSearch: false,
        value: this.getText(),
        onChange: this.onHandlerChange
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      return UdpComponent.propsToState(nextProps, prevState, ['value']);
    }
  }]);
  return _class2;
}(UdpComponent), 'Combobox');