import type { InputProps, PasswordProps, SearchProps, TextAreaProps } from 'antd/es/input';
import type { InputNumberProps } from 'antd/es/input-number';
import React from 'react';
export declare const Input: React.ForwardRefExoticComponent<Omit<Omit<InputProps & {
    formatter?: ((value: string) => string) | undefined;
    parser?: ((formatValue: string) => string) | undefined;
}, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => React.ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const InputNumber: React.ForwardRefExoticComponent<Omit<Omit<InputNumberProps<import("rc-input-number").ValueType> & {
    type?: "number" | "amount" | "percent" | "prc" | "amt" | "qty" | "rate" | undefined;
}, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => React.ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const TextArea: React.ForwardRefExoticComponent<Omit<Omit<TextAreaProps, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => React.ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const Password: React.ForwardRefExoticComponent<Omit<Omit<PasswordProps, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => React.ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const Search: React.ForwardRefExoticComponent<Omit<Omit<SearchProps, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => React.ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const InputTrigger: React.ForwardRefExoticComponent<Omit<InputProps & {
    onTrigger?: Function | undefined;
    editable?: boolean | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const InputNumberRange: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
