function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["options", "multiple", "style", "defaultValue", "disabled", "value"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useRefCallback } from '@cscec/udp-core';
import { Tooltip } from 'antd';
import { useEffect, useMemo, useState } from 'react';
import { Select } from "../../../baseComponent";
import { udp } from "../../../util";
import { saveAttachLabel } from "../service";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var defaultWidth = 150;
export function LabelSelect(props) {
  var labelConfig = props.labelConfig,
    fileId = props.fileId,
    onChangeCallback = props.onChangeCallback;
  var options = labelConfig.options,
    multiple = labelConfig.multiple,
    style = labelConfig.style,
    defaultValue = labelConfig.defaultValue,
    disabled = labelConfig.disabled,
    propsValue = labelConfig.value,
    others = _objectWithoutProperties(labelConfig, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    updating = _useState4[0],
    setUpdating = _useState4[1];
  var _useState5 = useState([]),
    _useState6 = _slicedToArray(_useState5, 2),
    value = _useState6[0],
    setValue = _useState6[1];
  var preValue = useMemo(function () {
    var v = propsValue || defaultValue;
    return Array.isArray(v) ? v : [v];
  }, [propsValue, defaultValue]);
  useEffect(function () {
    setValue(preValue);
  }, [preValue]);
  var handleLabelChange = useRefCallback(function (label) {
    setUpdating(true);
    var params = {
      fileId: fileId,
      label: label
    };
    saveAttachLabel(params).then(function (res) {
      if ((res === null || res === void 0 ? void 0 : res.code) === 0) {
        onChangeCallback && onChangeCallback();
      } else {
        setValue(defaultValue);
      }
    }).finally(function () {
      setUpdating(false);
    });
  });
  var newProps = _objectSpread({
    options: options,
    multiple: !!multiple,
    disabled: disabled,
    style: _objectSpread({
      width: defaultWidth,
      maxHeight: '100%'
    }, style)
  }, others);
  if (newProps.multiple) {
    newProps.maxTagCount = newProps.hasOwnProperty('maxTagCount') ? newProps.maxTagCount : 'responsive';
    newProps.maxTagPlaceholder = function (omittedValues) {
      var len = omittedValues === null || omittedValues === void 0 ? void 0 : omittedValues.length;
      if (len) {
        var tipTitle = /*#__PURE__*/_jsx("div", {
          style: {
            padding: '6px 8px',
            wordBreak: 'break-all',
            whiteSpace: 'normal'
          },
          onClick: function onClick(e) {
            return e.stopPropagation();
          },
          onMouseDown: function onMouseDown(e) {
            return e.stopPropagation();
          },
          children: omittedValues.map(function (v) {
            return v.label;
          }).join(', ')
        });
        return /*#__PURE__*/_jsx(Tooltip, {
          overlayInnerStyle: {
            padding: 0
          },
          title: tipTitle,
          mouseEnterDelay: 0.2,
          children: /*#__PURE__*/_jsxs("span", {
            style: {
              display: 'inline-flex',
              alignItems: 'center',
              maxWidth: '100%'
            },
            children: [/*#__PURE__*/_jsx("span", {
              className: "nowrap",
              style: {
                flex: 1
              },
              children: omittedValues[0].label
            }), len > 1 ? ",  + ".concat(len - 1, " ...") : ""]
          })
        });
      }
      return null;
    };
  }
  return /*#__PURE__*/_jsx(Select, _objectSpread(_objectSpread({}, newProps), {}, {
    open: open,
    loading: newProps.loading || updating,
    value: value,
    onDropdownVisibleChange: function onDropdownVisibleChange(_open) {
      setOpen(_open);
      if (!_open && preValue.join('') !== value.join('')) {
        handleLabelChange(value);
      }
    },
    onChange: function onChange(v) {
      var values = udp.isArray(value) ? v.map(function (op) {
        return op.value;
      }) : [v.value];
      if (!open) {
        handleLabelChange(values);
      }
      setValue(values);
    }
  }));
}