function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["permission", "uploadRef", "uploading", "isReady", "onToolbarClick"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { DownloadOutlined, FileAddOutlined, FileExcelOutlined } from '@ant-design/icons';
import { Space } from 'antd';
import { AttachmentButton, Upload } from "../components";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var editOrViewDataMap = {
  edit: {
    text: '编辑',
    param: 'Edit',
    fileTypeList: ['doc', 'docx', 'xls', 'xlsx']
  },
  view: {
    text: '查看',
    param: 'View',
    fileTypeList: ['doc', 'docx', 'xls', 'xlsx', 'pdf']
  }
};
export function Toolbar(props) {
  var permission = props.permission,
    uploadRef = props.uploadRef,
    uploading = props.uploading,
    isReady = props.isReady,
    onToolbarClick = props.onToolbarClick,
    rest = _objectWithoutProperties(props, _excluded);
  return /*#__PURE__*/_jsxs(Space, {
    size: [15, 10],
    wrap: true,
    children: [(permission === null || permission === void 0 ? void 0 : permission.add) === 2 ? null : /*#__PURE__*/_jsx(Upload, _objectSpread(_objectSpread({}, rest), {}, {
      ref: uploadRef,
      children: /*#__PURE__*/_jsx(AttachmentButton, {
        permissionStatus: permission === null || permission === void 0 ? void 0 : permission.add,
        disabled: !isReady || uploading,
        icon: /*#__PURE__*/_jsx(FileAddOutlined, {}),
        children: /*#__PURE__*/_jsx("span", {
          children: "\u65B0\u589E"
        })
      })
    })), /*#__PURE__*/_jsx(AttachmentButton, {
      permissionStatus: permission === null || permission === void 0 ? void 0 : permission.delete,
      icon: /*#__PURE__*/_jsx(FileExcelOutlined, {}),
      onClick: function onClick() {
        return onToolbarClick('delete');
      },
      children: "\u5220\u9664"
    }), /*#__PURE__*/_jsx(AttachmentButton, {
      permissionStatus: permission === null || permission === void 0 ? void 0 : permission.download,
      icon: /*#__PURE__*/_jsx(DownloadOutlined, {}),
      onClick: function onClick() {
        return onToolbarClick('download');
      },
      children: "\u4E0B\u8F7D"
    }), /*#__PURE__*/_jsx(AttachmentButton, {
      permissionStatus: permission === null || permission === void 0 ? void 0 : permission.zipDownload,
      icon: /*#__PURE__*/_jsx(DownloadOutlined, {}),
      onClick: function onClick() {
        return onToolbarClick('zipDownload');
      },
      children: "\u6253\u5305\u4E0B\u8F7D"
    })]
  });
}