import React from 'react';
import { type IBMapProps, type PromiseType } from '../../util';
export declare function openBMap(props: IBMapProps): Promise<PromiseType<{
    closeStatus?: 'ok' | 'cancel';
    value?: any;
}>>;
/**
 * 百度地图回显组件
 */
export declare const InputBMap: React.ForwardRefExoticComponent<Omit<InputBMapProps & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
interface InputBMapProps extends IBMapProps {
    value?: any;
    labelInValue?: boolean;
    disabled?: boolean;
    labelField?: string;
    onChange?: (...args: any[]) => void;
}
export {};
