import { CascaderProps } from 'antd';
import React from 'react';
interface AreaData {
    creator: string;
    dataName: string;
    dataNo: string;
    deleted: string;
    editor: string;
    id: string;
    insertDt: string;
    mainDataCode: string;
    mainDataFlg: number;
    recordVer: number;
    seq: number;
    status: number;
    sysSdSearchKey: number;
    sysShareFlg: number;
    tenantId: number;
    treeId: number;
    treePid: string;
    typeCode: string;
    updateDt: string;
    userModFlg: number;
}
type AntCascaderOption = {
    value: AreaData['dataName'];
    label: AreaData['dataName'];
    children: AntCascaderOption[];
    disabled?: boolean;
    isLeaf?: boolean;
    origin: AreaData;
};
type PickCascaderProps = 'allowClear' | 'autoFocus' | 'changeOnSelect' | 'className' | 'disabled' | 'expandTrigger' | 'size' | 'style' | 'onDropdownVisibleChange';
export interface AreaLinkageProps extends Pick<CascaderProps<AntCascaderOption>, PickCascaderProps> {
    id?: string;
    country?: string;
    fitHeight?: boolean;
    value?: string[];
    defaultValue?: string[];
    onChange?: (values: string[], options: AntCascaderOption[]) => void;
}
declare const AreaLinkageWithHoc: React.ForwardRefExoticComponent<Omit<AreaLinkageProps & {
    observer: any;
    outRef: any;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export { AreaLinkageWithHoc as AreaLinkage };
