import React from 'react';
import { IProjectEngineeringHelp } from './interface';
/**
 * 工程项目帮助
 * @returns
 */
export declare const ProjectEngineeringHelp: React.ForwardRefExoticComponent<Omit<import("./interface").IProjectEngineeringBaseHelp & Omit<import("../../../functionalComponent").IAsyncTreeProps, "request"> & {
    defaultSelectedFirstNode?: boolean | undefined;
    params?: import("../..").OrgTreeParamType | undefined;
    beforeRequest?: ((...args: any[]) => Promise<boolean | void>) | undefined;
    treeRequest?: ((params: import("../..").OrgTreeParamType) => Promise<any[]>) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
/**
 * 核算项目帮助-多选
 * @returns
 */
export declare const MultipleProjectEngineeringHelp: React.ForwardRefExoticComponent<Omit<IProjectEngineeringHelp, "multiple"> & React.RefAttributes<any>>;
export default ProjectEngineeringHelp;
