import { memo } from 'react';
import { Layout } from "../../../util";

/**
 * 用户帮助-项目
 * @param props
 * @returns
 */
import { jsx as _jsx } from "react/jsx-runtime";
function UserProjectHelp(props) {
  var renderTable = props.renderTable,
    multiple = props.multiple;
  return /*#__PURE__*/_jsx(Layout.Flex, {
    direction: "row",
    style: {
      height: '100%'
    },
    children: /*#__PURE__*/_jsx(Layout.Flex, {
      style: {
        paddingBottom: multiple ? 32 : 0
      },
      children: renderTable(0)
    })
  });
}
export default /*#__PURE__*/memo(UserProjectHelp);