import { InfoCircleFilled } from '@ant-design/icons';
import { Tooltip } from "../../../../functionalComponent";
import { Layout } from "../../../../util";

/**
 * 表格右上角动态显示提示控件
 *
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default (function (_ref) {
  var children = _ref.children,
    _ref$iconVisible = _ref.iconVisible,
    iconVisible = _ref$iconVisible === void 0 ? false : _ref$iconVisible;
  if (!iconVisible) {
    return /*#__PURE__*/_jsx(Layout.Flex, {
      direction: "column",
      children: children
    });
  }
  return /*#__PURE__*/_jsxs(Layout.Flex, {
    direction: "column",
    children: [/*#__PURE__*/_jsx("div", {
      style: {
        display: 'flex',
        justifyContent: 'flex-end',
        padding: 5
      },
      children: /*#__PURE__*/_jsx(Tooltip, {
        title: '在当前单据转换关系中，管理员配置了不允许重复引用来源数据，因此部分数据处于禁用状态。',
        children: /*#__PURE__*/_jsx(InfoCircleFilled, {
          style: {
            color: 'var(--color-waring)',
            justifyItems: 'flex-end'
          }
        })
      })
    }), /*#__PURE__*/_jsx(Layout.Flex, {
      children: children
    })]
  });
});