/// <reference types="react" />
import { Form } from 'antd';
import { formConfProps } from '../config/interface';
import './index.less';
import { FormInfo } from './interface';
export type { FormInfo } from './interface';
export { FormLayout, type InnerFormLayoutInterface };
declare const InnerFormLayout: import("react").ForwardRefExoticComponent<Omit<{
    id?: string | undefined;
    config?: formConfProps.FormFieldSet | undefined;
    setConfig?: ((config: formConfProps.FormFieldSet) => formConfProps.FormFieldSet) | undefined;
    confKey?: string[] | undefined;
    formStyle?: import("react").CSSProperties | undefined;
    style?: import("react").CSSProperties | undefined;
    size?: "small" | "large" | "middle" | undefined;
    compact?: boolean | undefined;
    className?: any;
    onLoad?: (() => void) | undefined;
    initSc?: any;
    formConf?: any;
    disabledNotify?: boolean | undefined;
} & {
    formConf?: any;
} & FormInfo & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
type InnerFormLayoutType = typeof InnerFormLayout;
interface InnerFormLayoutInterface extends InnerFormLayoutType {
    AntForm: typeof Form;
}
declare const FormLayout: InnerFormLayoutInterface;
