function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["data-item"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { udp } from "../../util";
import { getComp } from "../common";
import { jsx as _jsx } from "react/jsx-runtime";
var TextItem = getComp({
  xtype: 'Text'
}).instance;
export default function (props) {
  var item = props['data-item'],
    others = _objectWithoutProperties(props, _excluded);
  var src = props.src,
    value = props.value;
  var val = value;
  var Comp = TextItem;

  //图片
  if (src && item.xtype === 'Image' || item.xtype === 'Button') {
    Comp = getComp(item).instance;
  } else if (item.xtype === 'RangePicker') {
    val = Array.isArray(value) ? value.join('-') : value;
  } else if (Array.isArray(item.data || item.options)) {
    var dataList = item.data || item.options;
    if (Array.isArray(value)) {
      var sets = new Set(value);
      val = (item.data || item.options).filter(function (item) {
        return sets.has(item.value);
      }).map(function (item) {
        return item.label;
      }).join(',');
    } else {
      var _dataList$find;
      val = (_dataList$find = dataList.find(function (item) {
        return item.value === value;
      })) === null || _dataList$find === void 0 ? void 0 : _dataList$find.label;
    }
  } else if (Array.isArray(value)) {
    val = value.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.label;
    }).join(',');
  } else {
    var _val, _val2;
    val = ((_val = val) === null || _val === void 0 ? void 0 : _val.label) || ((_val2 = val) === null || _val2 === void 0 ? void 0 : _val2.toString());
  }
  if (udp.isNullOrEmpty(val)) {
    return null;
  }
  return /*#__PURE__*/_jsx(Comp, _objectSpread(_objectSpread({}, others), {}, {
    value: val
  }));
}