/// <reference types="react" />
import { formConfProps } from '../config/interface';
export type { GridViewInfo } from './interface';
export declare const GridView: import("react").ForwardRefExoticComponent<Omit<{
    id?: string | undefined;
    config?: formConfProps.GridView | undefined;
    setConfig?: ((config: formConfProps.GridView) => formConfProps.GridView) | undefined;
    confKey?: string[] | undefined;
    formStyle?: import("react").CSSProperties | undefined;
    style?: import("react").CSSProperties | undefined;
    size?: "small" | "large" | "middle" | undefined;
    compact?: boolean | undefined;
    className?: any;
    onLoad?: (() => void) | undefined;
    initSc?: any;
    formConf?: any;
    disabledNotify?: boolean | undefined;
} & {
    formConf?: any;
} & Omit<import("../..").GridPropsType, "columns"> & {
    busKey?: string | undefined;
    busFields?: string[] | undefined;
    columns?: import("../..").ColumnProps[] | ((configColumns: import("../..").ColumnProps[] | undefined) => import("../..").ColumnProps[] | undefined) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
