function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["fullScreen"];
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useRef } from 'react';
import { Layout, RightOutlined, udp, useRefValue, useUpdateEffect } from "../../util";
import { FullPage } from "../fullPage";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function InnerPanel(_ref) {
  var title = _ref.title,
    _ref$extra = _ref.extra,
    extra = _ref$extra === void 0 ? null : _ref$extra,
    children = _ref.children,
    style = _ref.style,
    className = _ref.className,
    bodyStyle = _ref.bodyStyle,
    headerStyle = _ref.headerStyle,
    _ref$autoFit = _ref.autoFit,
    autoFit = _ref$autoFit === void 0 ? false : _ref$autoFit,
    _ref$collapsible = _ref.collapsible,
    collapsible = _ref$collapsible === void 0 ? false : _ref$collapsible,
    _ref$showArrow = _ref.showArrow,
    showArrow = _ref$showArrow === void 0 ? true : _ref$showArrow,
    _ref$showPrefix = _ref.showPrefix,
    showPrefix = _ref$showPrefix === void 0 ? true : _ref$showPrefix,
    _ref$compact = _ref.compact,
    compact = _ref$compact === void 0 ? false : _ref$compact,
    _ref$open = _ref.open,
    open = _ref$open === void 0 ? true : _ref$open,
    onOpenChange = _ref.onOpenChange,
    innerRef = _ref.innerRef,
    blankStyle = _ref.blankStyle,
    flexDirection = _ref.flexDirection;
  var _useRefValue = useRefValue(open, true),
    _useRefValue2 = _slicedToArray(_useRefValue, 2),
    innerOpen = _useRefValue2[0],
    setInnerOpen = _useRefValue2[1];
  var layoutStyle = _objectSpread({
    backgroundColor: '#fff',
    borderRadius: 2,
    marginBottom: "".concat(autoFit || compact ? 0 : 'var(--inner-margin, 16px)')
  }, style);

  // 收起的时候需要把高度属性删掉，否则没法正常收起
  if (!innerOpen) {
    delete layoutStyle.minHeight;
    delete layoutStyle.flex;
    delete layoutStyle.height;
  }
  useUpdateEffect(function () {
    if (innerOpen !== open) {
      onOpenChange === null || onOpenChange === void 0 || onOpenChange(innerOpen);
    }
  }, [innerOpen]);
  var titleClick = function titleClick(e) {
    if (!collapsible) {
      return;
    }
    if (!e || e.target === e.currentTarget || e.target.parentNode === e.currentTarget || udp.closest(e.target, function (el) {
      var _el$classList;
      return (_el$classList = el.classList) === null || _el$classList === void 0 ? void 0 : _el$classList.contains('udp-collapse-handle');
    })) {
      setInnerOpen === null || setInnerOpen === void 0 || setInnerOpen(!innerOpen);
      return;
    }
  };
  var hasHeader = !!(collapsible || title || extra);
  var offset = compact ? -2 : 0;
  var getHeader = function getHeader() {
    var innerStyle = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (hasHeader) {
      return /*#__PURE__*/_jsxs("div", {
        className: udp.classNames('udp-panel-title'),
        onClick: titleClick,
        style: _objectSpread(_objectSpread({
          height: 'auto',
          minHeight: compact ? 36 : 45,
          cursor: "".concat(collapsible ? 'pointer' : 'default'),
          whiteSpace: 'nowrap',
          display: 'flex',
          alignItems: 'center',
          borderBottom: '1px solid rgba(0, 0, 0, 0.06)',
          paddingRight: 12
        }, innerStyle), headerStyle),
        children: [showPrefix && /*#__PURE__*/_jsx("div", {
          style: {
            backgroundColor: 'var(--primary-color)',
            width: 4,
            height: 12,
            flexShrink: 0
          }
        }), /*#__PURE__*/_jsx("div", {
          className: "udp-collapse-handle",
          style: {
            fontSize: 16 + offset,
            marginLeft: showPrefix ? 12 + offset : 16 + offset,
            fontWeight: 600
          },
          children: title || ''
        }), /*#__PURE__*/_jsx("span", {
          ref: innerRef,
          className: "udp-collapse-handle",
          style: _objectSpread({
            minWidth: 30,
            textAlign: 'right',
            flex: 1,
            width: 0
          }, blankStyle)
        }), extra, collapsible && showArrow ? /*#__PURE__*/_jsx("span", {
          style: {
            fontSize: 0,
            marginLeft: 8
          },
          children: /*#__PURE__*/_jsx(RightOutlined, {
            className: "udp-collapse-handle",
            style: {
              transition: 'all .3s ease',
              fontSize: 16,
              transform: "rotate(".concat(innerOpen ? 90 : 0, "deg)")
            }
          })
        }) : null]
      });
    }
    return null;
  };
  if (children) {
    return /*#__PURE__*/_jsxs(Layout, {
      autoFit: autoFit,
      className: udp.classNames('udp-panel', className),
      style: layoutStyle,
      children: [getHeader(), /*#__PURE__*/_jsx(Layout.Flex, {
        direction: flexDirection,
        style: _objectSpread(_objectSpread({
          padding: 16 + offset
        }, bodyStyle), {}, {
          display: "".concat(innerOpen ? 'block' : 'none')
        }),
        children: children
      })]
    });
  }
  if (hasHeader) {
    return /*#__PURE__*/_jsx("div", {
      className: udp.classNames('udp-panel', className),
      style: layoutStyle,
      children: getHeader({
        borderBottom: 0
      })
    });
  }
  return null;
}

/**
 * 容器组件
 */
export var Panel = /*#__PURE__*/React.forwardRef(function (_ref2, ref) {
  var _ref2$fullScreen = _ref2.fullScreen,
    fullScreen = _ref2$fullScreen === void 0 ? false : _ref2$fullScreen,
    props = _objectWithoutProperties(_ref2, _excluded);
  var hasHeader = !!(props.collapsible || props.title || props.extra);
  var innerRef = useRef(null);
  if (fullScreen && hasHeader) {
    return /*#__PURE__*/_jsx(FullPage, _objectSpread(_objectSpread({
      ref: ref,
      getIconContainer: function getIconContainer() {
        return innerRef.current;
      }
    }, fullScreen === true ? {} : fullScreen), {}, {
      children: /*#__PURE__*/_jsx(InnerPanel, _objectSpread(_objectSpread({}, props), {}, {
        innerRef: innerRef
      }))
    }));
  } else {
    return /*#__PURE__*/_jsx(InnerPanel, _objectSpread({}, props));
  }
});