/// <reference types="react" />
import { CheckboxGroupProps, CheckboxOptionType, CheckboxProps } from 'antd/es/checkbox';
import { SwitchProps } from 'antd/es/switch';
export interface ICheckboxExtraProps {
    checkedValue?: any;
    unCheckedValue?: any;
    value?: any;
    onChange?: (value: any) => void;
}
export declare const Checkbox: import("react").ForwardRefExoticComponent<Omit<Omit<CheckboxProps, keyof ICheckboxExtraProps> & ICheckboxExtraProps & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const Switch: import("react").ForwardRefExoticComponent<Omit<Omit<SwitchProps, keyof ICheckboxExtraProps> & ICheckboxExtraProps & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const CheckboxGroup: import("react").ForwardRefExoticComponent<Omit<CheckboxGroupProps<import("antd/es/checkbox/Group").CheckboxValueType> & {
    data?: CheckboxOptionType<import("antd/es/checkbox/Group").CheckboxValueType>[] | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
