/// <reference types="react" />
interface FileViewProps {
    style?: React.CSSProperties;
    data: {
        fileName: string;
        fileSize: number;
        status?: 'done' | 'error' | 'uploading' | 'removed' | 'fail';
        percent?: number;
    };
    isPreview?: boolean;
    handlePreview?: (file: any) => void;
    iconPosition?: 'left' | 'right';
}
export declare function FileView(props: FileViewProps): import("react/jsx-runtime").JSX.Element;
export {};
