var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/Attachment/components/RemarkModal.tsx
var RemarkModal_exports = {};
__export(RemarkModal_exports, {
  RemarkModal: () => RemarkModal
});
module.exports = __toCommonJS(RemarkModal_exports);
var import_antd = require("antd");
var import_react = require("react");
var import_functionalComponent = require("../../../functionalComponent");
var import_service = require("../service");
var RemarkModal = (props) => {
  const { data, visible, disabled, onCancel, onSaved } = props;
  const { asrFid, asrRemark } = data || {};
  const [remark, setRemark] = (0, import_react.useState)("");
  (0, import_react.useEffect)(() => {
    visible && setRemark(asrRemark);
  }, [asrRemark, visible]);
  return /* @__PURE__ */ React.createElement(
    import_antd.Modal,
    {
      open: visible,
      title: "修改备注",
      onOk: () => {
        if (disabled) {
          onCancel();
          return;
        }
        (0, import_service.tableAttachSaveRemark)({
          fileId: asrFid,
          remark
        }).then((res) => {
          if ((res == null ? void 0 : res.code) === 0) {
            import_functionalComponent.message.success("备注保存成功");
            onSaved();
            onCancel();
          }
        });
      },
      onCancel,
      okText: "保存"
    },
    /* @__PURE__ */ React.createElement(
      import_antd.Input.TextArea,
      {
        disabled,
        rows: 5,
        value: remark,
        onChange: (e) => setRemark(e.target.value),
        maxLength: 500
      }
    )
  );
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RemarkModal
});
