import { type IObject } from '../../util';
export declare const customRequest: IObject;
export declare const openTab: (title: string | undefined, url: any, params?: {}) => void;
export declare const downloadFile: (filename: any, blob: any, type?: string) => void;
export declare const getFileSize: (size: any) => any;
export declare const isJingeOpen: (fileType: any, showControl: any) => boolean;
export declare const getFileType: (fileName: string) => string;
export declare const getFileMd5: (file: any) => Promise<unknown>;
export declare const getFileMd5BySlice: (file: any, chunkSize?: number) => Promise<unknown>;
export declare function getSortNumArr(num?: number): number[];
export declare function asyncPool<T>(array: T[], limit: number, iteratorFn: (value: T, arr: T[]) => Promise<void>): Promise<void[]>;
export declare function getFileCenterApiUrl(relativeUrl: string): {
    absUrl: boolean;
    url: string;
};
