import { MutableRefObject } from 'react';
import { AttachmentFile } from '../../../../AttachmentContext';
import { UploadProps } from '../../../../components';
interface ImageUploadProps extends Pick<UploadProps, 'onUploaded' | 'onUploadStateChange' | 'onBeforeUpload' | 'onRemove' | 'disabled'> {
    attachmentFileList: AttachmentFile[];
    uploadRef: MutableRefObject<any>;
    accept?: string;
    maxCount?: number;
}
export declare function ImageUpload(props: ImageUploadProps): import("react/jsx-runtime").JSX.Element;
export {};
