var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/express/component/selectCtx/index.tsx
var selectCtx_exports = {};
__export(selectCtx_exports, {
  default: () => selectCtx_default
});
module.exports = __toCommonJS(selectCtx_exports);
var import_react = require("react");
var import_functionalComponent = require("../../../../functionalComponent");
var import_util = require("../../../../util");
var import_service = require("../../service");
var import_functionCtx = __toESM(require("../functionCtx"));
function selectCtx_default({ editor, setCurrentFunc, sendParams }) {
  const getBizTreeMemo = (0, import_react.useCallback)(() => {
    return () => {
      return (0, import_service.getExpressionFieldTree)(sendParams);
    };
  }, [sendParams]);
  const onSelect = (_, { node }) => {
    var _a, _b;
    (_b = (_a = editor.current) == null ? void 0 : _a.insertEdit) == null ? void 0 : _b.call(_a, { text: node.expressionDisplay, type: "field" });
  };
  const items = (0, import_react.useMemo)(() => {
    return [
      {
        key: "1",
        label: "函数",
        children: /* @__PURE__ */ React.createElement(import_functionCtx.default, { editor, setCurrentFunc })
      },
      {
        key: "2",
        label: "字段",
        children: /* @__PURE__ */ React.createElement(import_util.Layout.Flex, { style: { flex: 1, height: "100%" } }, /* @__PURE__ */ React.createElement(
          import_functionalComponent.AsyncTree,
          {
            virtual: false,
            request: getBizTreeMemo(),
            onSelect,
            icon: false,
            convertNode: (node) => {
              return {
                ...node,
                key: node.key,
                title: node.title,
                isLeaf: node.leaf
              };
            }
          }
        ))
      }
    ];
  }, [editor, getBizTreeMemo]);
  return /* @__PURE__ */ React.createElement(import_functionalComponent.Tabs, { defaultActiveKey: "1", fitHeight: true, items });
}
