var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/express/service.tsx
var service_exports = {};
__export(service_exports, {
  expressionValidate: () => expressionValidate,
  getExpressionFieldTree: () => getExpressionFieldTree,
  getExpressionFuncTree: () => getExpressionFuncTree
});
module.exports = __toCommonJS(service_exports);
var import_util = require("../../util");
async function getExpressionFuncTree() {
  const d = await import_util.udp.request.post({
    url: "/udp-rule-engine/rule/expression/getExpressionFuncTree"
  });
  return d.data;
}
async function getExpressionFieldTree(data) {
  const d = await import_util.udp.request.body({
    url: "/udp-rule-engine/rule/expression/getExpressionFieldTree",
    data
  });
  return d.data;
}
async function expressionValidate(data) {
  const d = await import_util.udp.request.body({
    url: "/udp-rule-engine/rule/expression/expressionValidate",
    data
  });
  return d.data;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  expressionValidate,
  getExpressionFieldTree,
  getExpressionFuncTree
});
