var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/print/service.ts
var service_exports = {};
__export(service_exports, {
  getPrintServer: () => getPrintServer,
  getPrintTemplate: () => getPrintTemplate
});
module.exports = __toCommonJS(service_exports);
var import_util = require("../../util");
var import_util2 = require("./util");
async function getPrintTemplate(params) {
  const { code, message, data } = await import_util.udp.request.body({
    url: "/portal/print/page",
    data: params
  });
  if (code === 0) {
    return data || {};
  } else {
    await (0, import_util2.wfAlert)(import_util2.info.alertTitle, message || import_util2.info.paramError);
  }
}
async function getPrintServer() {
  const resp = await import_util.udp.request.get({
    url: "/portal/print/getPrintServer"
  });
  return resp;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getPrintServer,
  getPrintTemplate
});
