import { ReactNode } from 'react';
export declare const NGLang: {
    alertTitle: string;
    paramError: string;
    noCallBack: string;
    bizHasRuningProcInst: string;
    bizHasNoFlowInfo: string;
    getPdListError: string;
    ProcessTraceViewTitle: string;
    terminateSuccess: string;
    terminateFailure: string;
    diagramViewerTitle: string;
    taskHisActor: string;
    taskHisMsg: string;
    taskHisActorDept: string;
    taskHisTime: string;
    taskHisNode: string;
    taskHisTaskDes: string;
    taskHisDuration: string;
    taskHisSignature: string;
    attach: string;
    focusPoint: string;
    submitTaskComplete: string;
    openNotWebError: string;
    noDeptData: string;
    signatureWinTitle: string;
    choseSignature: string;
    getSignature: string;
    hasNoSignature: string;
    getSignatureError: string;
    mustSignature: string;
    signaturePassword: string;
    pwd: string;
    noPwd: string;
    pwdError: string;
    perview: string;
    btnOk: string;
    btnCancel: string;
    btnNextTask: string;
    getFlowHisError: string;
    btnFeedBack: string;
    hasNoNextTask: string;
    btnFlowDiagram: string;
    btnFlowInfo: string;
    approvalPoint: string;
    btnAttach: string;
    attachCtlInitError: string;
    btnAbort: string;
    btnAddsubtis: string;
    btntransmit: string;
    btnrollback: string;
    confirmmatter: string;
    btnSubmit: string;
    btnDisagree: string;
    btnAgree: string;
    flowInfo: string;
    showNextNodeInfo: string;
    myopincommonuse: string;
    commonPhrases: string;
    emptyRemarkInfo: string;
    msgTypeSys: string;
    msgTypeSMS: string;
    msgContent: string;
    msgReceiver: string;
    hasNoremark: string;
    reamrkHasMore: string;
    hasNoMsgContent: string;
    hasNoMsgReceiver: string;
    taskReassignTo: string;
    taskReassSuccess: string;
    taskReassignError: string;
    taskReassignErrorMsg: string;
    whetherTerminate: string;
    addSubTasksSuccess: string;
    addSubTasksFailure: string;
    parentAutoComplete: string;
    sequential: string;
    getTaskDataInfo: string;
    checkApproveFailure: string;
    getTaskDynamicError: string;
    TaskCompleteSuccess: string;
    TaskCompleteError: string;
    checkCancelApprove: string;
    canNotCancelApprove: string;
    checkCancelApproveError: string;
    submitRollBack: string;
    rollBackSuccess: string;
    rollBackError: string;
    openNextTask: string;
    rollBackNodeWinTitle: string;
    nodeName: string;
    nodeId: string;
    reSetUser: string;
    hasNoRollBakNode: string;
    rollBackType: string;
    rollBackPartNodeWinTitle: string;
    dynamicBranchWinTitle: string;
    curNodeName: string;
    nodeMustHasChild: string;
    nodeMustOnlyOneChild: string;
    nodeDynamicUsers: string;
    user: string;
    notAllNodeSetUser: string;
    userSelectWinTitle: string;
    userSeachEmptyText: string;
    flowStartUser: string;
    nextAppName: string;
    allFlowUser: string;
    treeSeachEmptyText: string;
    seachEmptyText: string;
    userNo: string;
    userName: string;
    allUsers: string;
    flowUser: string;
    hasNoSelectData: string;
    notFindTreeNode: string;
    createFlowWinTitile: string;
    flowKeyWord: string;
    taskRemark: string;
    procDefin: string;
    pdId: string;
    pdName: string;
    description: string;
    btnView: string;
    btnTest: string;
    operation: string;
    createFlowErrorByNoChildNode: string;
    createFlow: string;
    startBatchFlow: string;
    startFlowSuccess: string;
    createFlowSuccess: string;
    createFlowError: string;
    selectOnePd: string;
    createFlowMinUserCount: string;
    batchStartFlowWinTitile: string;
    batchStartFlowNumberLimit: string;
    selectpsn: string;
    needReassignNodePersonnel: string;
    select: string;
    dynamicUsers: string;
    userId: string;
    userDept: string;
    userOrg: string;
    AddCommonUse: string;
    DelCommonUse: string;
    addCommonSuccess: string;
    removeCommonSuccess: string;
    batchStartFlowSuccess: string;
    FeedBackTitle: string;
    FeedBackReceive: string;
    FeedBackMsg: string;
    operatorHelp: string;
    feedbackSubmit: string;
    sendSuccess: string;
    sendError: string;
    selectAddPerson: string;
    selectReassignPerson: string;
    rollBackReason: string;
    choseRollBackReason: string;
    carbonCopy: string;
    carbonCopyUsersSelect: string;
    carbonCopyError: string;
    carbonCopySuccess: string;
    carbonCopySuccessContent: string;
    approvalProgress: string;
};
/**
 * 设置多语言
 * @param lang 多语言
 */
export declare function setNGLang(lang: any): void;
export declare const commonStyle: {
    borderStyle: {
        borderRadius: string;
        border: string;
    };
    backgroundStyle: {
        backgroundColor: string;
    };
};
interface IModal {
    title: string;
    width?: number;
    closable?: boolean;
    content: ReactNode;
    okText?: boolean | string;
    cancelText?: boolean | string;
    footerLeft?: ReactNode;
    onOk?: (...args: any[]) => any;
    onCancel?: (...args: any[]) => any;
}
/**
 * 弹窗
 * @param props
 */
export declare function wfModal(props: IModal): Promise<unknown>;
/**
 * 字符串format
 * @param format
 * @param args
 */
export declare function stringFormat(format: any, ...args: any[]): any;
/**
 * 取出数组中的交集
 * @a 普通的数组
 * @b 在数组对象中的数组
 */
export declare function filterUserNodes(a: any, b: any, key: any): any;
/**
 * 提示框
 * @param title 标题
 * @param content 提示内容
 */
export declare function wfAlert(title: any, content: any): Promise<unknown>;
/**
 * 确认对话框
 * @param title
 * @param content
 */
export declare function wfConfirm(title: any, content: any): Promise<unknown>;
/**
 * 消息反馈提示
 * @param content
 * @param duration
 */
export declare function wfMessage(content: any, duration?: number): import("antd/es/message/interface").MessageType;
export declare function reloadPage(): void;
/**
 * 获取人员类型
 * @param hasPsn
 * @param dynamicAny
 */
export declare function getUseDynamicType(hasPsn: any, dynamicAny: any): any;
/**
 * 流程模拟测试/流程查看
 * @param procInstId
 * @param bizId
 * @param bizPk
 */
export declare function showPdDiagram(row: any, workInFlow?: any): void;
/**
 * 流程追踪
 * @param bizCode
 * @param bizKey
 */
export declare function showFlowInfo(bizCode: any, bizKey: any): Promise<void>;
/**
 * 通过piId查看流程信息
 * @param procInstId
 */
export declare function showFlowInfoByPiId(procInstId: any): Promise<void>;
/**
 * 打开我的意见常用语
 */
export declare function openCommonWordList(): void;
/**
 * 递归遍历当前节点及其子节点
 * @param node 当前节点
 * @param callback 回调
 */
export declare function cascadeBy(node: any, callback: any): void;
/**
 * 打开工作流附件
 * @param record
 */
export declare function showTaskAttachment(record: any, status: any): Promise<void>;
/**
 * 判断是否portal进入且设置了连续办理
 */
export declare function getAutoNextFlag(): boolean;
/**
 * 获取下一个任务
 * @param taskid 当前任务id
 * @param catalogGroup
 */
export declare function getNextTask({ taskid, catalogGroup }: {
    taskid: any;
    catalogGroup: any;
}): Promise<import("@cscec/udp-core/src/interface/types/IRequestOptions").IResponse>;
/**
 * 打开下一个工作流任务办理页面
 * @param nextTaskData 下一个任务信息
 * @param isFromPortal 打开来源
 * @param isTaskList 是否工作流任务列表打开
 */
export declare function openNextAppFlowTask({ nextTaskData, isFromPortal, isTaskList }: {
    nextTaskData: any;
    isFromPortal: any;
    isTaskList: any;
}): Promise<void>;
/**
 * 获取toolbar实例
 * @param toolbar
 */
export declare function getToolbar(toolbar: any): any;
export declare function setWorkFlowUIState(uiInfo: any, buttonInfo?: any): void;
export {};
