/// <reference types="react" />
import { formConfProps } from '../config/interface';
import { FormSetPropsInfo } from './interface';
export { default as FormFieldSet } from './FormFieldSet';
export type { FormFieldSetInfo, FormSetInfo } from './interface';
export declare function FormSetComp(props: FormSetPropsInfo): import("react/jsx-runtime").JSX.Element;
declare const FormSet: import("react").ForwardRefExoticComponent<Omit<{
    id?: string | undefined;
    config?: formConfProps.FormSet | undefined;
    setConfig?: ((config: formConfProps.FormSet) => formConfProps.FormSet) | undefined;
    confKey?: string[] | undefined;
    formStyle?: import("react").CSSProperties | undefined;
    style?: import("react").CSSProperties | undefined;
    size?: "small" | "large" | "middle" | undefined;
    compact?: boolean | undefined;
    className?: any;
    onLoad?: (() => void) | undefined;
    initSc?: any;
    formConf?: any;
    disabledNotify?: boolean | undefined;
} & {
    formConf?: any;
} & {
    collapsible?: boolean | undefined;
    collapse?: boolean | string[] | undefined;
    value?: any;
    defaultValue?: boolean | string[] | undefined;
    disabled?: any;
    panelProps?: import("@cscec/udp-core/src/interface/types/ts.lib").IObject | undefined;
} & import("..").FormInfo & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export default FormSet;
