import type { ButtonProps, ButtonType } from 'antd/es/button';
import type { PopconfirmProps } from 'antd/es/popconfirm';
import React, { CSSProperties } from 'react';
interface IButton extends ButtonProps {
    containerId?: string;
    getClickParams?: Function;
}
export declare const Button: React.ForwardRefExoticComponent<Omit<IButton & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
interface IConfirmButton extends PopconfirmProps {
    type?: ButtonType;
    size?: 'small' | 'middle' | 'large';
    danger?: boolean;
    buttonStyle?: CSSProperties;
    buttonProps?: ButtonProps;
    onBeforeOpen?: React.MouseEventHandler<HTMLElement>;
}
export declare const ConfirmButton: React.ForwardRefExoticComponent<Omit<IConfirmButton & {
    id?: string | undefined;
}, "outRef"> & React.RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export {};
