var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/functionalComponent/antd/menu.tsx
var menu_exports = {};
__export(menu_exports, {
  Menu: () => Menu
});
module.exports = __toCommonJS(menu_exports);
var import_antd = require("antd");
var import_react = __toESM(require("react"));
function loopChildren(items, pKey = null) {
  return items.filter(Boolean).map((item, index) => {
    const { children: label, title, ...others } = item.props;
    const key = item.key ?? (pKey ? `${pKey}-${index}` : `${index}`);
    if (Array.isArray(label) && title) {
      return { key, label: title, ...others, children: loopChildren(label, key) };
    }
    return { key, label, ...others };
  });
}
var Menu = class extends import_react.default.Component {
  render() {
    const { children, ...props } = this.props;
    const newProps = {};
    if (children && !props.items) {
      const tmp = Array.isArray(children) ? children : [children];
      newProps.items = loopChildren(tmp);
    }
    return /* @__PURE__ */ import_react.default.createElement(import_antd.Menu, { ...props, ...newProps });
  }
};
Menu.SubMenu = import_antd.Menu.SubMenu;
Menu.Divider = import_antd.Menu.Divider;
Menu.Item = import_antd.Menu.Item;
Menu.ItemGroup = import_antd.Menu.ItemGroup;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Menu
});
