var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/functionalComponent/table/child/expand.tsx
var expand_exports = {};
__export(expand_exports, {
  ExpandIcon: () => ExpandIcon
});
module.exports = __toCommonJS(expand_exports);
var import_react = __toESM(require("react"));
var import_common = require("../base/common");
var import_util = require("../util");
var ExpandIcon = import_react.default.memo(({ row, rowIndex, icon, style = {} }) => {
  const { table } = (0, import_react.useContext)(import_common.TableContext);
  const expandField = table.getExpandField();
  const spanRef = (0, import_react.useRef)(null);
  const [expand, setExpand] = (0, import_react.useState)(row[expandField]);
  const switchExpand = (e) => {
    (0, import_util.stopPropagation)(e);
    setExpand(!expand);
    table.setExpand(rowIndex, !expand);
  };
  (0, import_react.useEffect)(() => {
    setExpand(row[expandField]);
  }, [row[expandField]]);
  if (icon) {
    return /* @__PURE__ */ import_react.default.createElement("span", { ref: spanRef, className: "row-expand-icon", style, onClick: switchExpand }, icon(expand));
  }
  return /* @__PURE__ */ import_react.default.createElement("span", { ref: spanRef, className: "default-icon row-expand-icon", style, onClick: switchExpand }, /* @__PURE__ */ import_react.default.createElement("span", { className: `${expand ? " row-expand-icon-expanded" : ""}` }));
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ExpandIcon
});
