/// <reference types="react" />
import { type DatePickerProps, type TimePickerProps } from 'antd';
import type { RangePickerProps } from 'antd/es/date-picker';
import toDayJs from 'dayjs';
import 'dayjs/locale/zh-cn';
export declare const DatePicker: import("react").ForwardRefExoticComponent<Omit<Omit<Omit<DatePickerProps<string | toDayJs.Dayjs>, "onChange"> & {
    onChange?: ((value: any) => void) | undefined;
} & {
    id?: string | undefined;
}, "outRef">, "ref"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const DateTimePicker: import("react").ForwardRefExoticComponent<Omit<Omit<Omit<DatePickerProps<string | toDayJs.Dayjs>, "onChange"> & {
    onChange?: ((value: any) => void) | undefined;
} & {
    id?: string | undefined;
}, "outRef">, "ref"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const RangePicker: import("react").ForwardRefExoticComponent<Omit<Omit<RangePickerProps, "onChange"> & {
    onChange?: ((value: any) => void) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
export declare const TimePicker: import("react").ForwardRefExoticComponent<Omit<Omit<Omit<TimePickerProps, "onChange"> & {
    onChange?: ((value: any) => void) | undefined;
} & {
    id?: string | undefined;
}, "outRef">, "ref"> & import("react").RefAttributes<import("@cscec/udp-core/src/interface/types/ts.lib").ICurrentObject<any>>>;
