function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { FolderFilled, SearchOutlined } from '@ant-design/icons';
import { useEffect, useMemo, useState } from 'react';
import { Input } from "../../../baseComponent";
import { Layout } from "../../../util";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export var CategoryTree = function CategoryTree(props) {
  var _props$data = props.data,
    data = _props$data === void 0 ? [] : _props$data,
    onSelect = props.onSelect,
    style = props.style;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    selectedKey = _useState2[0],
    setSelectedKey = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    searchName = _useState4[0],
    setSearchName = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    inputValue = _useState6[0],
    setInputValue = _useState6[1];
  // const mockData = new Array(20).fill({
  //   title: 'aaa',
  //   icon: <FolderFilled />,
  //   count: 0
  // }).map((item, index) => ({
  //   ...item,
  //   key: index,
  // }))
  var dataList = useMemo(function () {
    return data.map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        title: item.typeName,
        key: item.typeId,
        icon: /*#__PURE__*/_jsx(FolderFilled, {})
      });
    });
  }, [data]);
  var filterDataList = useMemo(function () {
    return dataList.filter(function (item) {
      return item.title.includes(searchName);
    });
  }, [dataList, searchName]);
  useEffect(function () {
    var _dataList$;
    (dataList === null || dataList === void 0 || (_dataList$ = dataList[0]) === null || _dataList$ === void 0 ? void 0 : _dataList$.key) != null && setSelectedKey(dataList[0].key);
  }, []);
  return /*#__PURE__*/_jsxs(Layout, {
    direction: "column",
    className: "attachment-category",
    style: style,
    children: [/*#__PURE__*/_jsx("div", {
      className: "attachment-category-search-container",
      children: /*#__PURE__*/_jsx(Input, {
        className: "attachment-category-search",
        bordered: false,
        value: inputValue,
        onChange: setInputValue,
        suffix: /*#__PURE__*/_jsx(SearchOutlined, {
          style: {
            color: 'rgba(0,0,0,.45)'
          },
          onClick: function onClick() {
            return setSearchName(inputValue);
          }
        })
      })
    }), /*#__PURE__*/_jsx("div", {
      className: "attachment-category-title",
      children: "\u5206\u7C7B\u540D\u79F0"
    }), /*#__PURE__*/_jsx(Layout.Flex, {
      className: "attachment-category-content",
      children: filterDataList.map(function (item) {
        return /*#__PURE__*/_jsxs("div", {
          className: "attachment-category-item ".concat(item.key === selectedKey ? 'attachment-category-item-selected' : ''),
          onClick: function onClick() {
            setSelectedKey(item.key);
            onSelect(item.key);
          },
          children: [+item.mustInput === 1 ? /*#__PURE__*/_jsx("span", {
            style: {
              color: 'red'
            },
            children: "*"
          }) : null, /*#__PURE__*/_jsx("span", {
            children: item.title
          }), /*#__PURE__*/_jsxs("span", {
            className: "attachment-category-item-count",
            children: ["\uFF08", item.count, "\uFF09"]
          })]
        }, item.key);
      })
    })]
  });
};