function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Modal } from 'antd';
import { useEffect, useState } from 'react';
import { Table } from "../../../functionalComponent";
import { getDownLoadList } from "../service";
import { jsx as _jsx } from "react/jsx-runtime";
export var DownloadRecordModal = function DownloadRecordModal(props) {
  var data = props.data,
    visible = props.visible,
    _props$setVisible = props.setVisible,
    setVisible = _props$setVisible === void 0 ? function () {} : _props$setVisible;
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    dataSource = _useState2[0],
    setDataSource = _useState2[1];
  var onCancel = function onCancel() {
    return setVisible(false);
  };
  var tableConfig = [{
    title: '下载人',
    dataIndex: 'userName',
    flex: 1
  }, {
    title: '下载时间',
    dataIndex: 'downloadTime',
    flex: 1
  }];
  useEffect(function () {
    var _ref = data || {},
      asrFid = _ref.asrFid;
    visible && getDownLoadList({
      fileId: asrFid
    }).then(function (res) {
      if ((res === null || res === void 0 ? void 0 : res.code) === 0) {
        var _res$data;
        setDataSource((_res$data = res === null || res === void 0 ? void 0 : res.data) !== null && _res$data !== void 0 ? _res$data : []);
      }
    });
  }, [data, visible]);
  return /*#__PURE__*/_jsx(Modal, {
    open: visible,
    title: "\u4E0B\u8F7D\u8BB0\u5F55",
    onOk: onCancel,
    onCancel: onCancel,
    children: /*#__PURE__*/_jsx(Table, {
      rowHeight: 40,
      columns: tableConfig,
      dataSource: dataSource,
      virtualScrolling: false
    })
  });
};