/// <reference types="react" />
import { AttachmentProviderProps } from '../../AttachmentContext';
import type { ITableAttachmentProps } from '../../interface';
import './index.less';
type OriginTableAttachmentProps = Pick<ITableAttachmentProps, 'tableStyle' | 'categoryStyle' | 'style' | 'labelConfig' | 'uploadRef'>;
export declare const OriginTableAttachment: (props: OriginTableAttachmentProps) => import("react/jsx-runtime").JSX.Element;
export declare const TableAttachment: import("react").ForwardRefExoticComponent<Omit<AttachmentProviderProps, "children"> & import("react").RefAttributes<unknown>>;
export {};
