function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useImperativeHandle, useMemo, useState } from 'react';
import { TextArea } from "../../../../baseComponent";
import { Tabs } from "../../../../functionalComponent";
import { borderStyle, cssVar } from "../../../../util";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function (_ref) {
  var currentFunc = _ref.currentFunc,
    childRef = _ref.childRef;
  var _useState = useState('1'),
    _useState2 = _slicedToArray(_useState, 2),
    activeKey = _useState2[0],
    setactiveKey = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    validInfo = _useState4[0],
    setValidInfo = _useState4[1];
  useImperativeHandle(childRef, function () {
    return {
      changeActiveKeyAndParmam: changeActiveKeyAndParmam
    };
  });
  var changeActiveKeyAndParmam = function changeActiveKeyAndParmam(n, d) {
    setactiveKey(n);
    if (typeof d === 'string') {
      setValidInfo(d);
    } else {
      setValidInfo(JSON.stringify(d));
    }
  };
  var items = useMemo(function () {
    return [{
      key: '1',
      label: '函数说明',
      children: /*#__PURE__*/_jsx("div", {
        style: _objectSpread({
          overflow: 'auto',
          height: '100%',
          padding: '4px 11px',
          borderRadius: 4
        }, borderStyle()),
        children: /*#__PURE__*/_jsx(FuncExplain, {
          info: currentFunc
        })
      })
    }, {
      key: '2',
      label: '公式校验',
      children: /*#__PURE__*/_jsx(FormulaField, {
        data: validInfo
      })
    }];
  }, [currentFunc, validInfo]);
  return /*#__PURE__*/_jsx("div", {
    style: {
      height: 150
    },
    children: /*#__PURE__*/_jsx(Tabs, {
      defaultActiveKey: "1",
      items: items,
      activeKey: activeKey,
      onChange: function onChange(d) {
        return setactiveKey(d);
      }
    })
  });
}
function FuncExplain(_ref2) {
  var info = _ref2.info;
  return info && /*#__PURE__*/_jsxs("div", {
    children: [/*#__PURE__*/_jsx("div", {
      style: {
        fontWeight: 'bold'
      },
      children: info.funcFullNameWithParam
    }), /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsx("span", {
        style: {
          fontWeight: 'bold'
        },
        children: "\u540D\u79F0:"
      }), /*#__PURE__*/_jsx("span", {
        children: info.funcChnName
      })]
    }), /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsx("span", {
        style: {
          fontWeight: 'bold'
        },
        children: "\u529F\u80FD:"
      }), /*#__PURE__*/_jsx("span", {
        children: info.funcExplain
      })]
    }), /*#__PURE__*/_jsxs("div", {
      className: 'params',
      children: [/*#__PURE__*/_jsx("span", {
        style: {
          fontWeight: 'bold'
        },
        children: "\u53C2\u6570:"
      }), /*#__PURE__*/_jsx("div", {
        className: 'paramsItem',
        children: info.params.map(function (item) {
          return /*#__PURE__*/_jsx("span", {
            children: item
          }, item);
        })
      })]
    }), /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsx("span", {
        style: {
          fontWeight: 'bold'
        },
        children: "\u8FD4\u56DE\u503C:"
      }), /*#__PURE__*/_jsx("span", {
        children: info.returnType
      })]
    })]
  });
}
function FormulaField(_ref3) {
  var data = _ref3.data;
  return /*#__PURE__*/_jsx(TextArea, {
    value: data,
    disabled: true,
    style: {
      height: '100%',
      background: '#fff',
      color: cssVar.textColor
    }
  });
}