function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useContext } from 'react';
import { BaseHelp, Button, HelpContext, Table, Tabs } from "../../functionalComponent";
import { compHoc, getGlobalConfig, Layout, useRefCallback } from "../../util";
import { useCtx, useHelp, useTabItems } from "./common";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function HelpContent() {
  var _useContext = useContext(HelpContext),
    ok = _useContext.ok,
    _useContext$contentPa = _useContext.contentParams,
    helpId = _useContext$contentPa.helpId,
    footer = _useContext$contentPa.footer,
    columns = _useContext$contentPa.columns,
    helpTitle = _useContext$contentPa.helpTitle,
    locale = _useContext.locale,
    randomKey = _useContext.randomKey;
  var _useCtx = useCtx(false),
    activeKey = _useCtx.activeKey,
    setActiveKey = _useCtx.setActiveKey,
    tabBarExtraContent = _useCtx.tabBarExtraContent,
    advancedSearch = _useCtx.advancedSearch,
    renderTreeList = _useCtx.renderTreeList,
    getResult = _useCtx.getResult,
    changeCommonData = _useCtx.changeCommonData;
  var renderTable = useRefCallback(function (index, listRequest) {
    if (index === 'treeStyle') {
      return renderTreeList();
    }
    return /*#__PURE__*/_jsx(Table, {
      id: "".concat(helpId, "_").concat(randomKey, "_").concat(index),
      style: {
        borderStyle: 'solid',
        borderColor: 'var(--border-color-split, #f0f0f0)',
        borderWidth: '0 1px 1px 1px'
      },
      columns: columns,
      pagination: {
        height: 32,
        align: 'left'
      },
      onRow: function onRow() {
        return {
          onDoubleClick: function onDoubleClick() {
            ok(getResult());
          }
        };
      },
      rowSelected: true,
      headerMenu: false,
      request: listRequest
    });
  });
  var items = useTabItems({
    renderTable: renderTable
  });
  return /*#__PURE__*/_jsxs(Layout, {
    children: [/*#__PURE__*/_jsx(BaseHelp.Header, {
      title: helpTitle || locale.singleTitle,
      children: tabBarExtraContent
    }), advancedSearch, /*#__PURE__*/_jsx(Layout.Flex, {
      direction: "column",
      style: {
        padding: '0 5px'
      },
      children: /*#__PURE__*/_jsx(Tabs, {
        className: "fit-height",
        size: "small",
        activeKey: activeKey,
        onChange: setActiveKey,
        items: items
      })
    }), /*#__PURE__*/_jsxs(BaseHelp.Footer, {
      getResult: getResult,
      children: [/*#__PURE__*/_jsx(Button, {
        style: {
          marginLeft: 5
        },
        onClick: changeCommonData,
        children: activeKey === 'commonData' ? locale.DelCommonUse : locale.AddCommonUse
      }), footer && /*#__PURE__*/_jsx("span", {
        children: footer
      })]
    })]
  });
}
export var SingleHelp = compHoc(function (props) {
  var _useHelp = useHelp(props),
    _useHelp2 = _slicedToArray(_useHelp, 2),
    helpProps = _useHelp2[0],
    modalProps = _useHelp2[1];
  var _getGlobalConfig$defa = getGlobalConfig().default.helpConfig,
    width = _getGlobalConfig$defa.width,
    height = _getGlobalConfig$defa.height;
  return /*#__PURE__*/_jsx(BaseHelp, _objectSpread(_objectSpread({}, helpProps), {}, {
    multiple: false,
    helpContent: HelpContent,
    modalProps: _objectSpread({
      width: width,
      height: height
    }, modalProps)
  }));
}, 'SingleHelp');
export var HelpSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/_jsx(SingleHelp, _objectSpread(_objectSpread({}, props), {}, {
    ref: ref,
    modal: false
  }));
});