import { Tooltip } from "../../functionalComponent";
import { udp } from "../../util";
import { jsx as _jsx } from "react/jsx-runtime";
export default function renderLabel(props) {
  var _udp$getPageLang$lang;
  var width = props.width,
    originLabel = props.label,
    langKey = props.langKey,
    labelAlign = props.labelAlign;
  var label = (_udp$getPageLang$lang = udp.getPageLang()[langKey]) !== null && _udp$getPageLang$lang !== void 0 ? _udp$getPageLang$lang : originLabel;
  var labelStyle = {
    width: width,
    display: '-webkit-box',
    textAlign: labelAlign || 'right',
    wordBreak: 'break-all',
    whiteSpace: 'normal',
    maxHeight: '35px',
    lineHeight: 1.25,
    overflow: 'hidden',
    WebkitLineClamp: 2,
    textOverflow: 'ellipsis',
    WebkitBoxOrient: 'vertical'
  };
  return /*#__PURE__*/_jsx(Tooltip, {
    title: label,
    overflow: true,
    placement: "top".concat(labelAlign === 'left' ? 'Left' : 'Right'),
    children: /*#__PURE__*/_jsx("span", {
      style: labelStyle,
      children: label
    })
  });
}