function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["formConf", "outRef", "type", "forceRender", "panelHeight"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useEffect, useState } from 'react';
import { Tabs } from "../../functionalComponent";
import { compHoc, getRegisterComponentWithProps, registerComponent, udp, useRefCallback, useRefValue } from "../../util";
import { LayConfWrap } from "../common";
import { Comp_Info } from "../config/baseConfig";
import "./index.less";
import { jsx as _jsx } from "react/jsx-runtime";
function TabPanelComp(props) {
  var _ref = props,
    formConf = _ref.formConf,
    outRef = _ref.outRef,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'line' : _ref$type,
    forceRender = _ref.forceRender,
    panelHeight = _ref.panelHeight,
    others = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(function () {
      return [];
    }),
    _useState2 = _slicedToArray(_useState, 2),
    panes = _useState2[0],
    setPanes = _useState2[1];
  var _useRefValue = useRefValue(props.activeKey, props.defaultActiveKey),
    _useRefValue2 = _slicedToArray(_useRefValue, 2),
    activeKey = _useRefValue2[0],
    setActiveKey = _useRefValue2[1];
  useEffect(function () {
    var _p$;
    var p = (Array.isArray(formConf) ? formConf : formConf.children || []).map(function (item) {
      item['key'] = item.id;
      return item;
    });
    setPanes(p);
    p.every(function (_ref2) {
      var key = _ref2.key;
      return key !== activeKey;
    }) && setActiveKey((_p$ = p[0]) === null || _p$ === void 0 ? void 0 : _p$.key);
  }, [formConf]);
  var onInnerChange = useRefCallback(function (key) {
    var _props$onChange;
    setActiveKey(key);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, key);
  });
  var getItems = function getItems() {
    var childArray = udp.flatArray(props.children || []);
    var t = childArray.reduce(function (acc, it) {
      var tabId = it.props && it.props['data-tabid'] || it.key;
      tabId && (acc[tabId] = it);
      return acc;
    }, {});
    var getChildItem = function getChildItem(item) {
      if (t[item.id]) {
        return t[item.id];
      } else {
        var Comp = (Comp_Info[item.xtype] || {
          instance: getRegisterComponentWithProps(item.xtype)[0] || item.xtype
        }).instance;
        if (Comp_Info[item.xtype]) return /*#__PURE__*/_jsx(Comp, {
          config: item
        });
        return udp.isFunction(Comp) ? /*#__PURE__*/_jsx(Comp, {
          config: item
        }) : Comp;
      }
    };
    return panes.filter(function (p) {
      return !p.hidden;
    }).map(function (pane) {
      var _t$pane$id;
      var contentItemProps = ((_t$pane$id = t[pane.id]) === null || _t$pane$id === void 0 ? void 0 : _t$pane$id.props) || {};
      return {
        label: pane.title,
        key: pane.id,
        forceRender: contentItemProps['data-forceRender'] || pane.forceRender || forceRender,
        children: /*#__PURE__*/_jsx("div", {
          style: {
            minHeight: contentItemProps.panelHeight || pane.height || panelHeight
          },
          children: getChildItem(pane)
        })
      };
    });
  };
  return /*#__PURE__*/_jsx(Tabs, _objectSpread(_objectSpread({}, others), {}, {
    type: type,
    ref: outRef,
    fitHeight: true,
    size: 'small',
    onChange: onInnerChange,
    activeKey: activeKey + '',
    style: props.style,
    className: udp.classNames('udp-tab-panel', props.className),
    items: getItems()
  }));
}
var TabPanel = compHoc(LayConfWrap(TabPanelComp));
export default TabPanel;
registerComponent({
  TabPanel: TabPanel
});