function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState } from 'react';
var defaultBreakPairs = {
  480: 1,
  576: 1,
  768: 2,
  992: 3,
  1200: 3,
  1600: 4,
  1900: 4
};
var defaultBreakPoints = [480, 576, 768, 992, 1200, 1600, 1900];
export default function useColspan(id, customColspan) {
  var _handleBreakPairs = handleBreakPairs(customColspan, _objectSpread({}, defaultBreakPairs), [].concat(defaultBreakPoints)),
    _handleBreakPairs2 = _slicedToArray(_handleBreakPairs, 2),
    k = _handleBreakPairs2[0],
    o = _handleBreakPairs2[1];
  var _useState = useState(function () {
      return o;
    }),
    _useState2 = _slicedToArray(_useState, 2),
    breakPairs = _useState2[0],
    setBreakPairs = _useState2[1];
  var _useState3 = useState(function () {
      return k;
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    breakPoints = _useState4[0],
    setBreakPoints = _useState4[1];

  //数组当作colspan处理
  function handleBreakPairs(breakPairs, dPairs, dPoints) {
    if (!breakPairs) return [dPoints, dPairs];
    if (typeof breakPairs === 'number') {
      Object.keys(dPairs).forEach(function (b) {
        dPairs[b] = breakPairs;
      });
    } else {
      if (Array.isArray(breakPairs)) {
        dPairs = (breakPoints || defaultBreakPoints).reduce(function (acc, point, index) {
          acc[point] = customColspan[index] || breakPairs[point];
          return acc;
        }, {});
      } else {
        dPoints = Object.keys(breakPairs).map(function (item) {
          return Number(item);
        }).sort(function (a, b) {
          return a - b;
        });
        dPairs = breakPairs;
      }
    }
    return [dPoints, dPairs];
  }
  function setBreakPairsOrPoints(breakPairs) {
    var _handleBreakPairs3 = handleBreakPairs(breakPairs, breakPairs, breakPoints),
      _handleBreakPairs4 = _slicedToArray(_handleBreakPairs3, 2),
      k = _handleBreakPairs4[0],
      o = _handleBreakPairs4[1];
    setBreakPairs(o);
    setBreakPoints(k);
  }
  return {
    breakPairs: breakPairs,
    breakPoints: breakPoints,
    setBreakPairs: setBreakPairsOrPoints
  };
}