import React, { ReactNode } from 'react';
import { TableInstance } from '../interface';
import { IObject } from '../util';
export declare function loopChildren(table: any, row: any, dataIndex: any, checked: any, rowIndex: any, loop?: boolean, updateRows?: IObject[], checkDisabled?: Function | undefined): boolean;
/**
 * 表头复选框
 */
export declare const AllCheckBox: React.NamedExoticComponent<{
    table: TableInstance;
    dataIndex?: string | undefined;
    checkDisabled?: Function | undefined;
    children?: ReactNode;
}>;
/**
 * 表体复选框
 * @param row
 * @param dataIndex
 * @param rowIndex
 * @param checkDisabled 自定义disabled权限
 * @constructor
 */
export declare const RowCheckBox: React.NamedExoticComponent<{
    table: TableInstance;
    row: IObject;
    dataIndex: string;
    rowIndex: number;
    checkDisabled?: Function | undefined;
}>;
