function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["local"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { cssVar, useRefCallback, useUpdateEffect } from "../util";
import { useContext, useEffect, useState } from 'react';
import { TableContext } from "../base/common";

/**
 * 排序按钮
 * @param dataIndex
 * @param sortable
 * @constructor
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export function OrderIcon(_ref) {
  var _ref$column = _ref.column,
    dataIndex = _ref$column.dataIndex,
    sortable = _ref$column.sortable;
  var _useContext = useContext(TableContext),
    table = _useContext.table,
    _useContext$table$sta = _useContext.table.state,
    orderBy = _useContext$table$sta.orderBy,
    columns = _useContext$table$sta.columns;
  var orderIndex = orderBy.findIndex(function (o) {
    return o[dataIndex] !== undefined;
  });
  var _useState = useState(orderIndex > -1 ? orderBy[orderIndex][dataIndex] : ''),
    _useState2 = _slicedToArray(_useState, 2),
    direction = _useState2[0],
    setDirection = _useState2[1];
  var comStyle = {
    margin: 2,
    cursor: 'pointer',
    borderLeft: '4px solid transparent',
    borderRight: '4px solid transparent'
  };
  var setOrder = useRefCallback(function () {
    var order = direction === 'desc' ? 'asc' : direction === 'asc' ? '' : 'desc';
    if (orderIndex > -1) {
      if (order) {
        orderBy[orderIndex][dataIndex] = order;
      } else {
        orderBy.splice(orderIndex, 1);
      }
    } else {
      orderBy.push(_defineProperty(_defineProperty({}, dataIndex, order), "local", sortable.local !== false));
    }
    var orders = _toConsumableArray(orderBy.sort(function (a, b) {
      var _columns$find, _columns$find2;
      var _ref2 = [Object.keys(a)[0], Object.keys(b)[0]],
        aIndex = _ref2[0],
        bIndex = _ref2[1];
      return (((_columns$find = columns.find(function (c) {
        return c.dataIndex === aIndex;
      })) === null || _columns$find === void 0 ? void 0 : _columns$find.idx) || 0) - (((_columns$find2 = columns.find(function (c) {
        return c.dataIndex === bIndex;
      })) === null || _columns$find2 === void 0 ? void 0 : _columns$find2.idx) || 0);
    }));
    setDirection(order);
    if (sortable.local !== false) {
      table.setOrderBy(orders, sortable.callback);
    } else {
      table.setExtraParam({
        orderBy: orders.filter(function (o) {
          return !o.local;
        }).map(function (_ref3) {
          var local = _ref3.local,
            item = _objectWithoutProperties(_ref3, _excluded);
          return item;
        })
      });
    }
  });
  useEffect(function () {
    return table.subscribe(function (_ref4) {
      var column = _ref4.column;
      column.dataIndex === dataIndex && setOrder();
    }, 'onHeaderCellClick');
  }, [dataIndex]);
  useUpdateEffect(function () {
    table.notify({
      direction: direction,
      dataIndex: dataIndex
    }, 'onDataSort');
  }, [direction]);
  return /*#__PURE__*/_jsxs("div", {
    className: "order hover-icon",
    style: {
      padding: '2px 0',
      display: direction ? 'block' : ''
    },
    children: [/*#__PURE__*/_jsx("div", {
      style: _objectSpread(_objectSpread({}, comStyle), {}, {
        borderBottom: "5px solid ".concat(direction === 'asc' ? cssVar.primaryColor : '#bfbfbf')
      })
    }), /*#__PURE__*/_jsx("div", {
      style: _objectSpread(_objectSpread({}, comStyle), {}, {
        borderTop: "5px solid ".concat(direction === 'desc' ? cssVar.primaryColor : '#bfbfbf')
      })
    })]
  });
}