var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/Attachment/components/DownloadRecordModal.tsx
var DownloadRecordModal_exports = {};
__export(DownloadRecordModal_exports, {
  DownloadRecordModal: () => DownloadRecordModal
});
module.exports = __toCommonJS(DownloadRecordModal_exports);
var import_antd = require("antd");
var import_react = require("react");
var import_functionalComponent = require("../../../functionalComponent");
var import_service = require("../service");
var DownloadRecordModal = (props) => {
  const { data, visible, setVisible = () => {
  } } = props;
  const [dataSource, setDataSource] = (0, import_react.useState)([]);
  const onCancel = () => setVisible(false);
  const tableConfig = [
    {
      title: "下载人",
      dataIndex: "userName",
      flex: 1
    },
    {
      title: "下载时间",
      dataIndex: "downloadTime",
      flex: 1
    }
  ];
  (0, import_react.useEffect)(() => {
    const { asrFid } = data || {};
    visible && (0, import_service.getDownLoadList)({
      fileId: asrFid
    }).then((res) => {
      if ((res == null ? void 0 : res.code) === 0) {
        setDataSource((res == null ? void 0 : res.data) ?? []);
      }
    });
  }, [data, visible]);
  return /* @__PURE__ */ React.createElement(import_antd.Modal, { open: visible, title: "下载记录", onOk: onCancel, onCancel }, /* @__PURE__ */ React.createElement(import_functionalComponent.Table, { rowHeight: 40, columns: tableConfig, dataSource, virtualScrolling: false }));
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DownloadRecordModal
});
