var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/download-excel/services.tsx
var services_exports = {};
__export(services_exports, {
  exportTemplate: () => exportTemplate,
  getByBizCode: () => getByBizCode
});
module.exports = __toCommonJS(services_exports);
var import_util = require("../../util");
var getByBizCode = async (data) => {
  try {
    const result = await import_util.udp.request.get({
      url: `engine/metadataExcelImportMain/getTemplateByBizCode`,
      data
    });
    if (result.code === 0) {
      return result;
    } else {
      import_util.udp.alert(result.message);
      return { data: {} };
    }
  } catch (e) {
    import_util.udp.alert("接口调用失败");
    return { data: {} };
  }
};
var exportTemplate = async (data) => {
  try {
    const result = await import_util.udp.request.body({
      url: `/engine/metadataExcelImportMain/exportCustomizeTemplate`,
      data
    });
    return result;
  } catch (e) {
    import_util.udp.alert("接口调用失败");
    return { code: 500, message: "失败" };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  exportTemplate,
  getByBizCode
});
