import { BizPoint, DataModelRequest, DefinitionRequest, DefinitionVersionRequest, EarlyWarningRequest, ValueType } from './types';
type Itype = TypeA | TypeB | TypeC | TypeD;
type TypeA = {
    type: 'dataModelRequest';
    value: DataModelRequest & {
        bizPoint: BizPoint;
    };
};
type TypeB = {
    type: 'definitionVersionRequest';
    value: DefinitionVersionRequest & {
        bizPoint: BizPoint;
    };
};
type TypeC = {
    type: 'definitionRequest';
    value: DefinitionRequest & {
        bizPoint: BizPoint;
    };
};
type TypeD = {
    type: 'earlyWarningRequest';
    value: EarlyWarningRequest & {
        bizPoint: BizPoint;
    };
};
interface Iprops {
    type: Itype;
    value?: ValueType;
}
export default function ({ type, value }: Iprops): import("react/jsx-runtime").JSX.Element;
export {};
