export interface insertContent {
    /** 文本 */
    text: string;
    /** 类型 */
    type: 'func' | 'field';
}
export interface TextareaEditorAPI {
    /** 文本插入 */
    insertEdit: (val: insertContent) => void;
    /** 获取已输入文本 */
    getHtmlValue: () => string;
    /** 设置输入文本 */
    setDefaultHtml: (str: string) => void;
    /** 向后回退一步 */
    back: () => void;
    /** 向前前进一步 */
    forward: () => void;
    /** 重置到初始值 */
    reset: () => void;
}
