var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/express/component/textareaEditor/utils.ts
var utils_exports = {};
__export(utils_exports, {
  getCursorPosition: () => getCursorPosition,
  setCursorPosition: () => setCursorPosition
});
module.exports = __toCommonJS(utils_exports);
var getCursorPosition = (ctrl) => {
  var _a, _b, _c, _d;
  let CaretPos = {
    start: 0,
    end: 0
  };
  if ((_a = ctrl == null ? void 0 : ctrl.resizableTextArea) == null ? void 0 : _a.textArea.selectionStart) {
    CaretPos.start = (_b = ctrl == null ? void 0 : ctrl.resizableTextArea) == null ? void 0 : _b.textArea.selectionStart;
  }
  if ((_c = ctrl == null ? void 0 : ctrl.resizableTextArea) == null ? void 0 : _c.textArea.selectionEnd) {
    CaretPos.end = (_d = ctrl == null ? void 0 : ctrl.resizableTextArea) == null ? void 0 : _d.textArea.selectionEnd;
  }
  return CaretPos;
};
var setCursorPosition = (ctrl, start, end) => {
  ctrl.focus();
  ctrl.resizableTextArea.textArea.setSelectionRange(start, end);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getCursorPosition,
  setCursorPosition
});
