var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/index.tsx
var businessComponent_exports = {};
__export(businessComponent_exports, {
  injectBusinessComponents: () => injectBusinessComponents
});
module.exports = __toCommonJS(businessComponent_exports);
__reExport(businessComponent_exports, require("./area-linkage"), module.exports);
__reExport(businessComponent_exports, require("./Attachment"), module.exports);
__reExport(businessComponent_exports, require("./BMap"), module.exports);
__reExport(businessComponent_exports, require("./download-excel"), module.exports);
__reExport(businessComponent_exports, require("./express"), module.exports);
__reExport(businessComponent_exports, require("./filterRules"), module.exports);
__reExport(businessComponent_exports, require("./grid"), module.exports);
__reExport(businessComponent_exports, require("./help"), module.exports);
__reExport(businessComponent_exports, require("./html-editor"), module.exports);
__reExport(businessComponent_exports, require("./imp"), module.exports);
__reExport(businessComponent_exports, require("./org-tree"), module.exports);
__reExport(businessComponent_exports, require("./print"), module.exports);
__reExport(businessComponent_exports, require("./project-tree"), module.exports);
__reExport(businessComponent_exports, require("./query-panel"), module.exports);
__reExport(businessComponent_exports, require("./work-flow"), module.exports);
var import_util = require("../util");
var import_grid = require("./grid");
var HelpCpts = __toESM(require("./help"));
var hasDefaultRegister = false;
function injectBusinessComponents(cpt, options) {
  if (!hasDefaultRegister) {
    hasDefaultRegister = true;
    Object.keys(HelpCpts).forEach((key) => {
      if (!["SingleHelp", "MultipleHelp"].includes(key) && !key.startsWith("Multiple") && key.endsWith("Help")) {
        (0, import_util.registerComponent)({ [`Multiple${key}`]: HelpCpts[key] }, { isHelp: true, defaultProps: { multiple: true } });
      }
      if (key.startsWith("Multiple")) {
        (0, import_util.registerComponent)({ [key]: HelpCpts[key] }, { isHelp: true, defaultProps: { multiple: true } });
      } else {
        (0, import_util.registerComponent)({ [key]: HelpCpts[key] }, { isHelp: true });
      }
    });
    (0, import_util.registerComponent)({ Grid: import_grid.Grid });
  }
  cpt && (0, import_util.registerComponent)(cpt, options);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  injectBusinessComponents,
  ...require("./area-linkage"),
  ...require("./Attachment"),
  ...require("./BMap"),
  ...require("./download-excel"),
  ...require("./express"),
  ...require("./filterRules"),
  ...require("./grid"),
  ...require("./help"),
  ...require("./html-editor"),
  ...require("./imp"),
  ...require("./org-tree"),
  ...require("./print"),
  ...require("./project-tree"),
  ...require("./query-panel"),
  ...require("./work-flow")
});
