var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/work-flow/WFApprovalProgress.tsx
var WFApprovalProgress_exports = {};
__export(WFApprovalProgress_exports, {
  default: () => WFApprovalProgress_default
});
module.exports = __toCommonJS(WFApprovalProgress_exports);
var import_react = __toESM(require("react"));
var import_functionalComponent = require("../../functionalComponent");
var import_service = require("./service");
var TAB_COMPLETED_KEY = "1";
var TAB_UNHANDLED_KEY = "2";
var WFApprovalProgress = (props) => {
  const { taskId } = props;
  const columns = [
    {
      dataIndex: "rows",
      title: "序号",
      width: 80,
      align: "center",
      render: (row) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, row.rowIndex + 1)
    },
    {
      title: "节点名称",
      dataIndex: "nodeName"
    }
  ];
  const queryCompletedNodeInfo = (0, import_react.useCallback)(({ pageIndex, pageSize }) => {
    return (0, import_service.getCompletedNodeInfo)({ taskId, pageSize, pageIndex });
  }, []);
  const queryUnHandledNodeInfo = (0, import_react.useCallback)(({ pageIndex, pageSize }) => {
    return (0, import_service.getUnHandledNodeInfo)({ taskId, pageSize, pageIndex });
  }, []);
  const tabItems = [
    {
      key: TAB_COMPLETED_KEY,
      label: "已办节点",
      children: /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Table, { request: queryCompletedNodeInfo, columns, bordered: true, pagination: true, style: { height: 360 } })
    },
    {
      key: TAB_UNHANDLED_KEY,
      label: "未办节点",
      children: /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Table, { request: queryUnHandledNodeInfo, columns, bordered: true, pagination: true, style: { height: 360 } })
    }
  ];
  return /* @__PURE__ */ import_react.default.createElement("div", { style: { padding: "5px 20px 0 20px" } }, /* @__PURE__ */ import_react.default.createElement(import_functionalComponent.Tabs, { defaultActiveKey: "1", items: tabItems }));
};
var WFApprovalProgress_default = WFApprovalProgress;
