var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/businessComponent/work-flow/WFocusPointWin.tsx
var WFocusPointWin_exports = {};
__export(WFocusPointWin_exports, {
  WFocusPointWin: () => WFocusPointWin
});
module.exports = __toCommonJS(WFocusPointWin_exports);
var import_react = require("react");
var import_util = require("../../util");
var import_functionalComponent = require("../../functionalComponent");
var import_configComponent = require("../../configComponent");
function WFocusPointWin({ callback, fields }) {
  const formRef = (0, import_util.useApi)();
  const mCtx = (0, import_react.useContext)(import_functionalComponent.ModalContext);
  (0, import_react.useEffect)(() => {
    mCtx.ins.setApi({
      invokeOkHandler: async () => {
        var _a;
        const api = (_a = formRef.current) == null ? void 0 : _a.getApi();
        try {
          const values = await api.validateForm();
          Object.keys(values).forEach((key) => {
            if (import_util.udp.isObject(values[key]) && values[key].hasOwnProperty("value")) {
              values[key] = values[key].value;
            }
          });
          mCtx.ins.destroy();
          callback(values);
        } catch (e) {
          console.log(e);
        }
      }
    });
  }, []);
  return /* @__PURE__ */ React.createElement(import_util.Layout, { style: { height: 300, padding: "15px 5px 0 5px" } }, /* @__PURE__ */ React.createElement(import_configComponent.Form, { ref: formRef, colspan: 1, config: fields }));
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  WFocusPointWin
});
