var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/configComponent/config/baseConfig.ts
var baseConfig_exports = {};
__export(baseConfig_exports, {
  Comp_Info: () => Comp_Info
});
module.exports = __toCommonJS(baseConfig_exports);
var import_baseComponent = require("../../baseComponent");
var import_functionalComponent = require("../../functionalComponent");
var import_basePropType = require("./basePropType");
var import_fromItem = require("./fromItem");
var GRoup = { instance: "Group" };
var Comp_Info = {
  FormPanel: GRoup,
  container: GRoup,
  Text: { instance: import_fromItem.Text },
  CheckBoxGroup: {
    instance: import_baseComponent.Checkbox,
    props: {
      unCheckedValue: (0, import_basePropType.anyProp)(false),
      checkedValue: (0, import_basePropType.anyProp)(true),
      inputValue: (0, import_basePropType.anyProp)(true),
      uncheckedValue: (0, import_basePropType.anyProp)(false)
    }
  },
  Checkbox: {
    instance: import_baseComponent.Checkbox,
    props: {
      unCheckedValue: (0, import_basePropType.anyProp)(false),
      checkedValue: (0, import_basePropType.anyProp)(true),
      inputValue: (0, import_basePropType.anyProp)(true),
      uncheckedValue: (0, import_basePropType.anyProp)(false)
    }
  },
  Switch: {
    instance: import_baseComponent.Switch,
    props: {
      unCheckedValue: (0, import_basePropType.anyProp)(false),
      checkedValue: (0, import_basePropType.anyProp)(true),
      inputValue: (0, import_basePropType.anyProp)(true),
      uncheckedValue: (0, import_basePropType.anyProp)(false)
    }
  },
  CheckboxGroup: {
    instance: import_baseComponent.CheckboxGroup,
    props: {
      data: (0, import_basePropType.anyProp)([])
    }
  },
  TextArea: {
    instance: import_baseComponent.TextArea,
    props: {
      placeholder: (0, import_basePropType.strProp)(""),
      help: (0, import_basePropType.strProp)(""),
      readOnly: (0, import_basePropType.getSPT)(false, "booleanData"),
      maxLength: (0, import_basePropType.numberProp)(void 0),
      allowClear: import_basePropType.selectorPropTypes.booleanProp,
      showCount: (0, import_basePropType.getSPT)(false, "booleanData"),
      autoSize: (0, import_basePropType.anyProp)(false)
    }
  },
  Input: {
    instance: import_baseComponent.Input,
    props: {
      placeholder: (0, import_basePropType.strProp)(""),
      help: (0, import_basePropType.strProp)(""),
      autoComplete: (0, import_basePropType.strProp)("off"),
      readOnly: (0, import_basePropType.getSPT)(false, "booleanData"),
      maxLength: (0, import_basePropType.numberProp)(void 0),
      allowClear: import_basePropType.selectorPropTypes.booleanProp
    },
    listener: {
      onChange: `function onChange(val,event){debugger; console.log("----",val,event)}`
    }
  },
  InputNumber: {
    instance: import_baseComponent.InputNumber,
    props: {
      precision: (0, import_basePropType.numberProp)(0),
      readOnly: import_basePropType.selectorPropTypes.booleanProp,
      min: (0, import_basePropType.numberProp)(0),
      max: (0, import_basePropType.numberProp)(void 0),
      step: (0, import_basePropType.numberProp)(1)
    }
  },
  InputNumberRange: {
    instance: import_baseComponent.InputNumberRange,
    props: {}
  },
  Select: {
    instance: import_baseComponent.Select,
    props: {
      data: import_basePropType.arrayProp,
      valueField: (0, import_basePropType.strProp)("value"),
      labelField: (0, import_basePropType.strProp)("label"),
      mode: (0, import_basePropType.strProp)(""),
      getPopupContainer: import_basePropType.selectorPropTypes.booleanProp
    },
    children: "Radio"
  },
  DatePicker: {
    instance: import_baseComponent.DatePicker,
    props: {
      getPopupContainer: import_basePropType.selectorPropTypes.booleanProp
    }
  },
  RangePicker: {
    instance: import_baseComponent.RangePicker,
    props: {
      getPopupContainer: import_basePropType.selectorPropTypes.booleanProp
    }
  },
  DateTimePicker: {
    instance: import_baseComponent.DatePicker,
    props: {
      showTime: (0, import_basePropType.getSPT)(true, "booleanData"),
      getPopupContainer: import_basePropType.selectorPropTypes.booleanProp
    },
    defaultProps: {
      showTime: true
    }
  },
  TimePicker: {
    instance: import_baseComponent.TimePicker,
    props: {
      getPopupContainer: import_basePropType.selectorPropTypes.booleanProp
    }
  },
  Password: { instance: import_baseComponent.Password },
  Button: { instance: import_functionalComponent.Button, props: { children: (0, import_basePropType.strProp)("") } },
  Image: { instance: import_baseComponent.Image },
  Radio: { instance: import_baseComponent.Radio },
  RadioGroup: { instance: import_baseComponent.RadioGroup }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Comp_Info
});
