import { ComponentClass, FunctionComponent } from 'react';
export declare const strProp: (dv: string, writeable?: boolean, cnLabel?: any) => {
    type: string;
    defaultValue: string;
    editor: import("react").ForwardRefExoticComponent<Omit<Omit<import("antd").InputProps & {
        formatter?: ((value: string) => string) | undefined;
        parser?: ((formatValue: string) => string) | undefined;
    }, "onChange" | "tooltip"> & {
        onChange?: ((value: any) => void) | undefined;
        tooltip?: string | true | ((value: any) => import("react").ReactNode) | undefined;
    } & {
        id?: string | undefined;
    }, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src").ICurrentObject<any>>>;
    writeable: boolean;
    cnLabel: any;
};
export declare const numberProp: (dv: number | any, writeable?: boolean, cnLabel?: any) => {
    type: string;
    defaultValue: any;
    editor: import("react").ForwardRefExoticComponent<Omit<Omit<import("antd").InputNumberProps<import("rc-input-number").ValueType> & {
        type?: "number" | "amount" | "percent" | "prc" | "amt" | "qty" | "rate" | undefined;
    }, "onChange" | "tooltip"> & {
        onChange?: ((value: any) => void) | undefined;
        tooltip?: string | true | ((value: any) => import("react").ReactNode) | undefined;
    } & {
        id?: string | undefined;
    }, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src").ICurrentObject<any>>>;
    writeable: boolean;
    cnLabel: any;
};
export declare const arrayProp: {
    type: string;
    defaultValue: {
        value: string;
        label: string;
    }[];
    editor: import("react").ForwardRefExoticComponent<Omit<Omit<import("antd").InputProps & {
        formatter?: ((value: string) => string) | undefined;
        parser?: ((formatValue: string) => string) | undefined;
    }, "onChange" | "tooltip"> & {
        onChange?: ((value: any) => void) | undefined;
        tooltip?: string | true | ((value: any) => import("react").ReactNode) | undefined;
    } & {
        id?: string | undefined;
    }, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src").ICurrentObject<any>>>;
    writeable: boolean;
};
export declare const anyProp: (dv: any, w?: boolean, editor?: import("react").ForwardRefExoticComponent<Omit<Omit<import("antd").InputProps & {
    formatter?: ((value: string) => string) | undefined;
    parser?: ((formatValue: string) => string) | undefined;
}, "onChange" | "tooltip"> & {
    onChange?: ((value: any) => void) | undefined;
    tooltip?: string | true | ((value: any) => import("react").ReactNode) | undefined;
} & {
    id?: string | undefined;
}, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src").ICurrentObject<any>>>) => {
    type: string;
    defaultValue: any;
    editor: import("react").ForwardRefExoticComponent<Omit<Omit<import("antd").InputProps & {
        formatter?: ((value: string) => string) | undefined;
        parser?: ((formatValue: string) => string) | undefined;
    }, "onChange" | "tooltip"> & {
        onChange?: ((value: any) => void) | undefined;
        tooltip?: string | true | ((value: any) => import("react").ReactNode) | undefined;
    } & {
        id?: string | undefined;
    }, "outRef"> & import("react").RefAttributes<import("@cscec/udp-core/src").ICurrentObject<any>>>;
    writeable: boolean;
};
export declare const customProp: (dv: any, editor: ComponentClass | FunctionComponent, writeable?: boolean) => {
    type: string;
    defaultValue: any;
    editor: ComponentClass<{}, any> | FunctionComponent<{}>;
    writeable: boolean;
};
type selectData = Array<{
    value: boolean | string;
    label: string;
}>;
export declare const selectorProp: (dv: any, data: selectData, writeable?: boolean, cnLabel?: string) => {
    type: string;
    defaultValue: any;
    editor: (props: any) => import("react/jsx-runtime").JSX.Element;
    writeable: boolean;
    cnLabel: string | undefined;
};
export declare const selectorPropTypes: {
    booleanProp: {
        type: string;
        defaultValue: any;
        editor: (props: any) => import("react/jsx-runtime").JSX.Element;
        writeable: boolean;
        cnLabel: string | undefined;
    };
    textAlignProp: {
        type: string;
        defaultValue: any;
        editor: (props: any) => import("react/jsx-runtime").JSX.Element;
        writeable: boolean;
        cnLabel: string | undefined;
    };
    xtypeProp: {
        type: string;
        defaultValue: any;
        editor: (props: any) => import("react/jsx-runtime").JSX.Element;
        writeable: boolean;
        cnLabel: string | undefined;
    };
};
export declare function getSPT(dv: any, type: 'booleanData' | 'textAlignData' | 'xtypeData', writeable?: boolean, cnLabel?: string): {
    type: string;
    defaultValue: any;
    editor: (props: any) => import("react/jsx-runtime").JSX.Element;
    writeable: boolean;
    cnLabel: string | undefined;
};
export {};
