var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/configComponent/form/handleStyle.tsx
var handleStyle_exports = {};
__export(handleStyle_exports, {
  Label: () => Label,
  getFormStyle: () => getFormStyle
});
module.exports = __toCommonJS(handleStyle_exports);
function getFormStyle(formConf, rowStyle) {
  return {
    justifyContent: formConf.justifyContent || "flex-start",
    flexWrap: "wrap",
    marginLeft: 0,
    marginRight: 0,
    ...rowStyle,
    ...formConf.style
  };
}
function Label(formConf, item, required) {
  const labeWidth = item.labelWidth || formConf.labelWidth || 120;
  const labelAlign = item.labelAlign || formConf.labelAlign || "right";
  const style = {
    display: "inline-block",
    width: `${labeWidth}px`,
    textAlign: labelAlign,
    marginRight: "10px",
    color: required ? "red" : ""
  };
  return /* @__PURE__ */ React.createElement("span", { style }, item.label);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Label,
  getFormStyle
});
