var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/configComponent/getInitVals.ts
var getInitVals_exports = {};
__export(getInitVals_exports, {
  getInitVals: () => getInitVals
});
module.exports = __toCommonJS(getInitVals_exports);
var import_common = require("./common");
function getInitVals(layConf, type, defaultValue) {
  let iv;
  if (layConf && layConf.children) {
    switch (type) {
      case "form": {
        iv = defaultValue || {};
        const loop = (items) => {
          items.forEach((item) => {
            if (item.xtype === "container") {
              loop(item.items || item.children || []);
            } else if (item.name && item.hasOwnProperty("defaultValue") && (0, import_common.getObjValue)(iv, item.name) === void 0) {
              (0, import_common.setObjValue)(iv, item.name, item.defaultValue);
            }
          });
        };
        loop((layConf == null ? void 0 : layConf.children) || []);
        break;
      }
      case "grid":
        iv = defaultValue || [];
        break;
      default:
        iv = {};
    }
  }
  return iv;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getInitVals
});
