/// <reference types="react" />
export type TimeoutID = {
    id: number;
};
export declare function cancelTimeout(timeoutID: TimeoutID): void;
export declare function requestTimeout(callback: Function, delay: number): TimeoutID;
export declare function shallowDiffers(prev: Object, next: Object, exceptKey?: string): boolean;
export declare function areEqual(prevProps: any, nextProps: any): boolean;
export declare enum CellTypeEnum {
    BodyCell = 0,
    MergeCell = 1,
    AggregateCell = 2,
    FixedBodyCell = 3,
    ExpandRowCell = 4,
    GroupRowCell = 5,
    ZwCell = 6
}
export declare enum UpdateFlagEnum {
    None = 0,
    ColumnChecked = 1,
    RowUpdate = 2,
    UserUpdate = 3,
    ForceUpdate = 4
}
export declare enum TableSelectionModel {
    ROW = 0,
    CHECKBOX = 1,
    MULTIPLE_INTERVAL = 2
}
export declare const AttachmentTemp: unique symbol;
export declare const IS_GROUP: unique symbol;
export declare const IS_EXPANDED: unique symbol;
export declare const TableContext: import("react").Context<{
    table: Record<string, any>;
    columns: Record<string, any>;
}>;
export declare const DsContext: import("react").Context<Record<string, any>[]>;
