import { ConfigProviderProps } from 'antd/es/config-provider';
import { SpinProps } from 'antd/es/spin';
import 'dayjs/locale/zh-cn';
import React from 'react';
import { IWaterMarkProps } from '../util';
import './base.less';
interface IRootProps {
    children: React.ReactNode;
    componentSize?: 'small' | 'middle' | 'large';
    spinProps?: SpinProps;
    waterMark?: IWaterMarkProps | boolean;
    configProvider?: ConfigProviderProps;
}
/**
 * 根组件
 * @param children
 * @param componentSize
 * @param spinProps
 * @param waterMark 水印
 * @constructor
 */
export declare function RootContainer({ children, componentSize, spinProps, waterMark, configProvider }: IRootProps): import("react/jsx-runtime").JSX.Element;
export {};
